// Code generated by mockery v2.39.1. DO NOT EDIT.

package mocks

import (
	context "context"

	mock "github.com/stretchr/testify/mock"
	models "gitlab.com/timofeev.pavel.art/wallet/internal/models"
)

// WalletProvider is an autogenerated mock type for the WalletProvider type
type WalletProvider struct {
	mock.Mock
}

// CreateWallet provides a mock function with given fields: ctx, wallet
func (_m *WalletProvider) CreateWallet(ctx context.Context, wallet models.Wallet) error {
	ret := _m.Called(ctx, wallet)

	if len(ret) == 0 {
		panic("no return value specified for CreateWallet")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, models.Wallet) error); ok {
		r0 = rf(ctx, wallet)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// DeleteWalletByID provides a mock function with given fields: ctx, walletID
func (_m *WalletProvider) DeleteWalletByID(ctx context.Context, walletID int) error {
	ret := _m.Called(ctx, walletID)

	if len(ret) == 0 {
		panic("no return value specified for DeleteWalletByID")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, int) error); ok {
		r0 = rf(ctx, walletID)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// GetWalletByID provides a mock function with given fields: ctx, walletID
func (_m *WalletProvider) GetWalletByID(ctx context.Context, walletID int) (models.Wallet, error) {
	ret := _m.Called(ctx, walletID)

	if len(ret) == 0 {
		panic("no return value specified for GetWalletByID")
	}

	var r0 models.Wallet
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, int) (models.Wallet, error)); ok {
		return rf(ctx, walletID)
	}
	if rf, ok := ret.Get(0).(func(context.Context, int) models.Wallet); ok {
		r0 = rf(ctx, walletID)
	} else {
		r0 = ret.Get(0).(models.Wallet)
	}

	if rf, ok := ret.Get(1).(func(context.Context, int) error); ok {
		r1 = rf(ctx, walletID)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetWalletListByUserID provides a mock function with given fields: ctx, userID
func (_m *WalletProvider) GetWalletListByUserID(ctx context.Context, userID string) ([]models.Wallet, error) {
	ret := _m.Called(ctx, userID)

	if len(ret) == 0 {
		panic("no return value specified for GetWalletListByUserID")
	}

	var r0 []models.Wallet
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) ([]models.Wallet, error)); ok {
		return rf(ctx, userID)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) []models.Wallet); ok {
		r0 = rf(ctx, userID)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]models.Wallet)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, userID)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// UpdateWalletByID provides a mock function with given fields: ctx, id, wallet
func (_m *WalletProvider) UpdateWalletByID(ctx context.Context, id int, wallet models.Wallet) error {
	ret := _m.Called(ctx, id, wallet)

	if len(ret) == 0 {
		panic("no return value specified for UpdateWalletByID")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, int, models.Wallet) error); ok {
		r0 = rf(ctx, id, wallet)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// NewWalletProvider creates a new instance of WalletProvider. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func NewWalletProvider(t interface {
	mock.TestingT
	Cleanup(func())
}) *WalletProvider {
	mock := &WalletProvider{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
